<template>
  <LayoutMain>
    <section>
      <b-container>
        <b-row align-h="center">
          <b-col cols="12">
            <TitleShape title="Gestión usuarios" />
          </b-col>
        </b-row>
      </b-container>
      <div class="color-wrapper">
      <b-container>

        <!-- FILTER -->
        <b-row class="text-right">
          <b-col lg="6" class="my-1">
            <b-form-group label="Buscador" label-cols-sm="3" label-align-sm="right" label-size="sm" label-for="filterInput" class="mb-0">
              <b-input-group size="sm">
                <b-form-input v-model="filter"  :debounce=filterDebounce type="search" id="filterInput" placeholder="Nombre de usuario"></b-form-input>
                <b-input-group-append>
                  <b-button :disabled="!filter" @click="filter = ''">Clear</b-button>
                </b-input-group-append>
              </b-input-group>
            </b-form-group>
          </b-col>
        </b-row>
        <!-- FIN FILTER -->

        <b-row align-h="center">
          <b-col cols="12">
            <b-table :items="itemsProvider" :busy="isLoading" class="mt-3" outlined id="user-table" :current-page="currentPage"
            :per-page="perPage" :fields="fields" :filter="filter">
              <!-- loading -->
              <template #table-busy>
                <div class="text-center text-danger my-2">
                  <b-spinner class="align-middle"></b-spinner>
                  <strong>Loading...</strong>
                </div>
              </template>
              <!-- COLUMNA DE EDICION -->
              <template #cell(actions)="row">                
                <!-- BOTON BORRAR -->
                <a href="#" @click="showDeleteModal(row.item, row.index, $event.target)" title="Borrar usuario">
                    <eva-icon name=trash-2-outline width="1.5rem" height="1.5rem" animation="pulse"></eva-icon>
                </a>               
                <!-- INFOMODAL -->
              </template>
            </b-table>
             <b-pagination 
              v-model="currentPage"
              :total-rows="rows"
              :per-page="perPage"
              aria-controls="user-table"
            ></b-pagination>
          </b-col>
        </b-row>

        <b-modal :id="deleteModal.id" :title="deleteModal.title" @hide="resetDeleteModal" @ok="handleDelete">    
          Confirma para eliminar al usuario {{deleteModal.item.title}}
        </b-modal>
      </b-container>
      </div>
    </section>
    <b-container class="mt-3">
      <b-row>
          <b-col cols="6">
            <b-button size="lg" v-on:click="$router.go(-1)" variant="secondary" >Volver</b-button>
          </b-col>
      </b-row>
    </b-container>
  </LayoutMain>
</template>

<script>
// @ is an alias to /src
import LayoutMain from "@/components/layouts/Main.vue";
import TitleShape from "@/components/TitleShape.vue";
import SingleSpecial from "@/components/SingleSpecial.vue";
import { mapState, mapGetters } from "vuex";

export default {
  name: "acount",
  components: {
    LayoutMain,
    TitleShape,
    SingleSpecial
  },
  data() {
      return {
        rows: null,
        categories: [],
        perPage: 15,
        currentPage: 1,
        filter: null,
        filterDebounce: 500,
        fields: [
          { key: 'id', label: 'id'},
          { key: 'name', label: 'Nombre'},
          { key: 'email', label: 'Email'},
          { key: 'created_at', label: 'Alta usuario', 
            formatter: (value, key, item) => {
              return new Date(value).toISOString()
            }
          },
          { key: 'actions', label: 'Acciones', class: 'text-center' },          
        ],
        deleteModal: {
          id: 'delete-modal',
          title: '',
          item: ''
        }
      }
  },
  computed: {
    //Mapeo los getters del módulo auth para poder emplear sus funciones.
    ...mapGetters("user", ["isLoading"])
  },
  methods: {
    itemsProvider(ctx, callback) { // <- callback needs to be added here
      let page =  ctx.currentPage
      let perPage =  ctx.perPage
      let filter = ctx.filter
      callback([])
      this.$store.dispatch('user/index', {page, perPage, filter}).then(resp => {
        const items = resp.data
        this.rows = resp.meta.total
        this.perPage = resp.meta.per_page
        this.currentPage = resp.meta.current_page
        callback(items)
      }).catch(error => {
        callback([])
        console.debug(error)      
      });
      return null
    },
    //INFOMODAL
    showDeleteModal(item, index, button) {
        this.deleteModal.title = 'Borrar usuario'
        this.deleteModal.item = item
        this.$root.$emit('bv::show::modal', this.deleteModal.id, button)
      },
      //NO CREO QUE SEA NECESARIO
      resetDeleteModal() {
        this.deleteModal.title = ''
        this.deleteModal.item = ''
      },
      handleDelete(bvModalEvt) {
        // Prevent modal from closing
        bvModalEvt.preventDefault()
        console.log(this.deleteModal.item.id)     
        this.$store.dispatch('user/delete', {id: this.deleteModal.item.id}).then(resp => {
          this.$bvModal.hide(this.deleteModal.id)
           this.$root.$bvToast.toast(`Usuario eliminado con éxito`, {
            title: 'Eliminado',
            autoHideDelay: 5000,
            variant: 'success'
          })    
          this.$root.$emit('bv::refresh::table','user-table')       
        }).catch(error => {
          this.$bvModal.hide(this.deleteModal.id)
          this.$root.$bvToast.toast(error.message, {
            title: 'Error al elminar',
            autoHideDelay: 5000,
            variant: 'danger'
          })
        })
      }
  }
};
</script>